# -*- coding: utf-8 -*-
"""
Created on Sat May 15 10:45:34 2021

@author: nerea
"""
import numpy as np
import matplotlib.pyplot as plt
import Talkak3DOrokor as talk
import random


if __name__ == "__main__":
    N = 2
    D = np.empty((N))
    D.fill(0.01)
    Dij = (np.transpose(np.ones([N, N])*D) + np.ones([N, N])*D)/2
    m = np.empty((N))
    m.fill(1.0)
    n_list = np.array([1, 0.9, 0.4, 0.0])
    while True:
        x1 = random.random()
        x2 = random.random()
        if abs(x1 - x2) > D[0]:
            break

    v1 = random.random()
    v2 = random.random()
    sigma = (v1 + v2)/2
    h = D[0]/(5*sigma)
    print(h)
    loop = int((x1 + x2)/sigma/h)
    for n in n_list:

        x = np.array([x1, -x2])
        y = np.array([0.0, 0.0])
        z = np.array([0.0, 0.0])

        vx = np.array([-v1, v2])
        vy = np.array([0.0, 0.0])
        vz = np.array([0.0, 0.0])

        x_all = np.empty((N, loop), dtype=float)
        y_all = np.empty((N, loop), dtype=float)
        z_all = np.empty((N, loop), dtype=float)

        ez = np.empty((loop), dtype=float)
        x_all[:, 0] = x
        y_all[:, 0] = y
        z_all[:, 0] = z

        ez[0] = talk.energiaZinetiko(m, vx, vy, vz)

        for t in range(1, loop):
            vx, vy, vz = talk.talkaEbatzi(N, Dij, n, m, x, y, z, vx, vy, vz)
            x = x + vx*h
            y = y + vy*h
            z = z + vz*h  
    
            x_all[:, t] = x
            y_all[:, t] = y
            z_all[:, t] = z
            ez[t] = talk.energiaZinetiko(m, vx, vy, vz)
            
        denbora = np.linspace(0, loop-1, num=loop, dtype=float)
        plt.plot(denbora, ez, label='n=' + str(n), linewidth=1.5)
    plt.title('h =' + str(round(h, 6)))
    plt.xlabel('Denbora')
    plt.ylabel('Energia Zinetikoa')
    plt.legend()
    plt.show()