# -*- coding: utf-8 -*-
"""
Created on Sat May 15 10:45:34 2021

@author: nerea
"""
import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits import mplot3d
import time
import KutxaKlasea as kutxa
from itertools import count
from matplotlib.animation import FuncAnimation, PillowWriter
import os
import Talkak3DOrokor as talk


def update_plot1(i, xmax, xmin, ymax, ymin, zmax, zmin):
    axis.cla()
    axis.set_xlim3d(xmin, xmax)
    axis.set_ylim3d(ymin, ymax)
    axis.set_zlim3d(zmin, zmax)
    rx = x_all[:, i]
    ry = y_all[:, i]
    rz = z_all[:, i]
    axis.scatter(rx[0], ry[0], rz[0], color='red', s=10)
    axis.plot(x_all[0, 0:i+1], y_all[0, 0:i+1], z_all[0, 0:i+1], color='red',
              linewidth=1)
    axis.scatter(rx[1:N], ry[1:N], rz[1:N], color='blue', s=10)


if __name__ == "__main__":
    karpeta = 0
    while True:
        try:
            os.mkdir('Gas-partikulak_Emaitza' + str(karpeta))
            karpetaIzena = 'Gas-partikulak_Emaitza' + str(karpeta)
            break
        except OSError:
            karpeta = karpeta + 1

    if os.name == 'posix':
        slash = '/'
    else:
        slash = '\\'

    fitx1 = open(str(karpetaIzena) + str(slash) + 'Informazioa' +
                 str(karpeta) + '.txt', 'w')
    aldea = 1
    kutxa = kutxa.Kutxa(0.0, 0.0, 0.0, aldea)
    N = 100
    D = np.empty((N))
    D.fill(0.08)
    m = np.empty((N))
    m.fill(1)
    n = 1
    x = np.random.choice([-1, 1], size=N)*aldea*np.random.random_sample(N)/2
    y = np.random.choice([-1, 1], size=N)*aldea*np.random.random_sample(N)/2
    z = np.random.choice([-1, 1], size=N)*aldea*np.random.random_sample(N)/2

    vx = np.random.normal(loc=0.0, scale=10, size=N)
    vy = np.random.normal(loc=0.0, scale=10, size=N)
    vz = np.random.normal(loc=0.0, scale=10, size=N)

    loop = 100  # Zenbat denbora pausu kalkulatuko diren
    jump = 1  # Zenbat datu grafikatuko diren
    h = 0.001
    x_all = np.empty((N, int(loop/jump)), dtype=float)
    y_all = np.empty((N, int(loop/jump)), dtype=float)
    z_all = np.empty((N, int(loop/jump)), dtype=float)

    x_all[:, 0] = x
    y_all[:, 0] = y
    z_all[:, 0] = z


    exet = time.time()

    fitx1.write('N = ' + str(N) + '\n')
    fitx1.write('n = ' + str(n) + '\n')
    fitx1.write('aldea = ' + str(aldea) + '\n')
    fitx1.write('h = ' + str(h) + '\n')
    fitx1.write('loop = ' + str(loop) + '\n')

    fitx1.write('\n----------Masa-------------\n')
    np.savetxt(fitx1, m, delimiter=' ', newline=' ')
    fitx1.write('\n----------Diametroa-------------\n')
    np.savetxt(fitx1, D, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako x-------------\n')
    np.savetxt(fitx1, x, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako y-------------\n')
    np.savetxt(fitx1, y, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako z-------------\n')
    np.savetxt(fitx1, z, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako vx-------------\n')
    np.savetxt(fitx1, vx, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako vy-------------\n')
    np.savetxt(fitx1, vy, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako vz-------------\n')
    np.savetxt(fitx1, vz, delimiter=' ', newline=' ')

    fitx2 = open(str(karpetaIzena) + str(slash) + 'Datuak' +
                str(karpeta) + '.txt', 'w')
    np.savetxt(fitx2, x, delimiter=' ', newline=' ')
    np.savetxt(fitx2, y, delimiter=' ', newline=' ')
    np.savetxt(fitx2, z, delimiter=' ', newline=' ')
    fitx2.write('\n')
    Dij = (np.transpose(np.ones([N, N])*D) + np.ones([N, N])*D)/2

    for t in range(1, loop):

        vx, vy, vz= talk.talkaEbatzi(N, Dij, n, m, x, y, z, vx, vy, vz)
        vx, vy, vz = kutxa.KutxaTxokea(n, x, y, z, vx, vy, vz)
        x = x + vx*h
        y = y + vy*h
        z = z + vz*h
        np.savetxt(fitx2, x, delimiter=' ', newline=' ')
        np.savetxt(fitx2, y, delimiter=' ', newline=' ')
        np.savetxt(fitx2, z, delimiter=' ', newline=' ')
        fitx2.write('\n')

        if t % jump == 0:
            x_all[:, int(t/jump)] = x
            y_all[:, int(t/jump)] = y
            z_all[:, int(t/jump)] = z

    # --------------------GRAFIKATZEA----------------------
    fig = plt.figure()
    xmin = -kutxa.aldea/2
    xmax = kutxa.aldea/2
    ymin = -kutxa.aldea/2
    ymax = kutxa.aldea/2
    zmin = -kutxa.aldea/2
    zmax = kutxa.aldea/2
    axis = plt.axes(projection='3d', facecolor='black')


    # -----------DATUAK GORDE-----------------
    fitx1.write('\n----------Azken x-------------\n')
    np.savetxt(fitx1, x, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken y-------------\n')
    np.savetxt(fitx1, y, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken z-------------\n')
    np.savetxt(fitx1, z, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken vx-------------\n')
    np.savetxt(fitx1, vx, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken vy-------------\n')
    np.savetxt(fitx1, vy, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken vz-------------\n')
    np.savetxt(fitx1, vz, delimiter=' ', newline=' ')
    fitx1.close()
    fitx2.close()
    print('Exekuzio denbora ' + str(round(time.time() - exet, 2)) +
          's izan da.')
    axis.cla()
    axis.set_xlim3d(xmin, xmax)
    axis.set_ylim3d(ymin, ymax)
    axis.set_zlim3d(zmin, zmax)
    axis.grid(True)
    rx = x_all[:, loop-1]
    ry = y_all[:, loop-1]
    rz = z_all[:, loop-1]
    
    axis.scatter(rx[0], ry[0], rz[0], color='red', s=20)
    axis.plot(x_all[0, 0:loop], y_all[0, 0:loop], z_all[0, 0:loop], color='red', linewidth=1)
    fig.savefig(str(karpetaIzena) + str(slash) + 'PartikulaBakarra' +
                 str(karpeta) + '.png')
    axis.cla()
    axis.set_xlim3d(xmin, xmax)
    axis.set_ylim3d(ymin, ymax)
    axis.set_zlim3d(zmin, zmax)
    axis.grid(True)
    axis.scatter(rx[0], ry[0], rz[0], color='red', s=30)
    axis.plot(x_all[0, 0:loop], y_all[0, 0:loop], z_all[0, 0:loop], color='red',
              linewidth=1)

    axis.scatter(rx[1:N], ry[1:N], rz[1:N], color='blue',s=10)
    fig.savefig(str(karpetaIzena) + str(slash) + 'PartikulaGuztiak' +
                str(karpeta) + '.png')
    axis.cla()
    axis.grid(False)
    axis.set_axis_off()
    axis.set_xlim3d(xmin, xmax)
    axis.set_ylim3d(ymin, ymax)
    axis.set_zlim3d(zmin, zmax)
    zein = np.linspace(0, loop-1, num=int(loop/jump), dtype=int)
    franerate = 100
    frame = iter(list(zein))
    anim = FuncAnimation(fig, update_plot1, frames=frame, interval=1.0/franerate,
                         repeat=True, fargs= (xmax, xmin, ymax, ymin, zmax,
                                              zmin),  save_count=int(loop/jump))
    plt.show()