# -*- coding: utf-8 -*-
"""
Created on Thu Sep 17 17:14:00 2020

@author: nerea
"""
import numpy as np
from matplotlib.animation import FuncAnimation, PillowWriter
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d
from itertools import count
from os import name


"""Karpetaren zenbakia finkatu"""


def update_plot(i, xmax, xmin, ymax, ymin, zmax, zmin):
    ax.cla()
    ax.set_xlim3d(xmin, xmax)
    ax.set_ylim3d(ymin, ymax)
    ax.set_zlim3d(zmin, zmax)

    x = r[i, 0:N]
    y = r[i, N:2*N]
    z = r[i, 2*N:3*N]
    ax.scatter(x[0], y[0], z[0], color='red', s=100)
    ax.set_title('t = ' + str(round(i*h, 3)))
    ax.plot(r[0:i+1, 0], r[0:i+1, N], r[0:i+1, 2*N], color='red', linewidth=1)
    ax.scatter(x[1:N], y[1:N], z[1:N], color='blue')


if __name__ == "__main__":
    if name == 'posix':
        slash = '/'
    else:
        slash = '\\'
    karpeta = 0

    franerate = 1000  # Zenbat fotograma segunduko
    karpetaIzena = 'Gas-partikulak_Emaitza' + str(karpeta)

    fitx1 = open(str(karpetaIzena) + str(slash) + 'Informazioa' +
                 str(karpeta) + '.txt', 'r')
    while True:
        esaldi = fitx1.readline()
        if esaldi.split()[0] == 'N':
            N = int((esaldi.split())[2])
        elif esaldi.split()[0] == 'loop':
            loop = int((esaldi.split())[2])
            break
        elif esaldi.split()[0] == 'aldea':
            aldea = float((esaldi.split())[2])
        elif esaldi.split()[0] == 'h':
            h = float((esaldi.split())[2])

    fitx1.close()

    filename2 = karpetaIzena + slash + 'Datuak' + str(karpeta) + '.txt'
    r = np.array(np.loadtxt(filename2, dtype=float))

    fig = plt.figure()
    ax = plt.axes(projection='3d')
    ax.set_xlim3d(-aldea/2, aldea/2)
    ax.set_ylim3d(-aldea/2, aldea/2)
    ax.set_zlim3d(-aldea/2, aldea/2)
    loop = 50
    irudiKop = loop  # Zenbat irudiz eratutako gif-a nahi dudan
    zein = np.linspace(0, loop-1, num=loop, dtype=int)
    frame = iter(list(zein))
    anim = FuncAnimation(fig, update_plot, frames=None, interval=1.0/franerate,
                         repeat=False, fargs=(aldea/2, -aldea/2, aldea/2,
                                              -aldea/2, aldea/2, -aldea/2),
                                              save_count=irudiKop)
    plt.show()
    writergif = PillowWriter(fps=franerate)
    anim.save(karpetaIzena + slash + 'Gif' + str(karpeta) + '.gif',
              writer=writergif)
