# -*- coding: utf-8 -*-
"""
Created on Sat May  1 13:24:16 2021

@author: nerea

Programa honek iada egin den simulazio bateko datuak jaso eta luzatu egiten du
"""

import numpy as np
import time
import os
import Talkak3DOrokor as talk
import Grabitatea3DOrokor as grab


if __name__ == "__main__":

    aber = time.time()
    loop = 400
    kont = 1
    karpeta = 0
    karpetaIzena = 'Grabitazio-kolapsoa_Emaitza' + str(karpeta)

    if os.name == 'posix':
        slash = '/'
    else:
        slash = '\\'
    fitx1 = open(str(karpetaIzena) + str(slash) + 'Informazioa' +
                 str(karpeta) + '.txt', 'r')
    esaldi = fitx1.readline()
    N = int((esaldi.split())[2])
    esaldi = fitx1.readline()
    D = float((esaldi.split())[2])
    esaldi = fitx1.readline()
    n = float((esaldi.split())[2])
    esaldi = fitx1.readline()
    G = float((esaldi.split())[2])
    esaldi = fitx1.readline()
    h = float((esaldi.split())[2])
    esaldi = fitx1.readline()
    loop0 = int((esaldi.split())[2])
    esaldi = fitx1.readline()
    mtot = float((esaldi.split())[2])
    m = np.full((N), mtot)
    while True:
        esaldi = fitx1.readline()
        if esaldi == '----------Hasierako x-------------\n':
            esaldi = fitx1.readline()
            x0 = esaldi.split()
            x0 = np.array(x0, dtype=float)
        elif esaldi == '----------Hasierako y-------------\n':
            esaldi = fitx1.readline()
            y0 = esaldi.split()
            y0 = np.array(y0, dtype=float)
        elif esaldi == '----------Hasierako z-------------\n':
            esaldi = fitx1.readline()
            z0 = esaldi.split()
            z0 = np.array(z0, dtype=float)
        elif esaldi == '----------Hasierako vx-------------\n':
            esaldi = fitx1.readline()
            vx0 = esaldi.split()
            vx0 = np.array(vx0, dtype=float)
        elif esaldi == '----------Hasierako vy-------------\n':
            esaldi = fitx1.readline()
            vy0 = esaldi.split()
            vy0 = np.array(vy0, dtype=float)
        elif esaldi == '----------Hasierako vz-------------\n':
            esaldi = fitx1.readline()
            vz0 = esaldi.split()
            vz0 = np.array(vz0, dtype=float)
            esaldi = fitx1.readline()
            Time = float((esaldi.split())[2])
        elif esaldi == '----------Azken x-------------\n':
            esaldi = fitx1.readline()
            x = esaldi.split()
            x = np.array(x, dtype=float)
        elif esaldi == '----------Azken y-------------\n':
            esaldi = fitx1.readline()
            y = esaldi.split()
            y = np.array(y, dtype=float)
        elif esaldi == '----------Azken z-------------\n':
            esaldi = fitx1.readline()
            z = esaldi.split()
            z = np.array(z, dtype=float)
        elif esaldi == '----------Azken vx-------------\n':
            esaldi = fitx1.readline()
            vx = esaldi.split()
            vx = np.array(vx, dtype=float)
        elif esaldi == '----------Azken vy-------------\n':
            esaldi = fitx1.readline()
            vy = esaldi.split()
            vy = np.array(vy, dtype=float)
        elif esaldi == '----------Azken vz-------------\n':
            esaldi = fitx1.readline()
            vz = esaldi.split()
            vz = np.array(vz, dtype=float)
            break
    fitx1.close()

    fitx2 = open(str(karpetaIzena) + str(slash) + 'Datuak' +
                 str(karpeta) + '.txt', 'a')

    Dij = (np.transpose(np.ones([N, N])*D) + np.ones([N, N])*D)/2
    for t in range(0, loop):
        x = x + vx*h
        y = y + vy*h
        z = z + vz*h
        vx, vy, vz = talk.talkaEbatzi(N, Dij, n, m, x, y, z, vx, vy, vz)
        ax, ay, az = grab.axyz(N, G, Dij, m, x, y, z)
        vx = vx + ax*h
        vy = vy + ay*h
        vz = vz + az*h
        np.savetxt(fitx2, x, delimiter=' ', newline=' ')
        np.savetxt(fitx2, y, delimiter=' ', newline=' ')
        np.savetxt(fitx2, z, delimiter=' ', newline=' ')
        fitx2.write('\n')
        if t % int(loop/5) == 0:
            print(str(loop-t) + "  iterazio geratzen dira.")

    fitx1 = open(str(karpetaIzena) + str(slash) + 'Informazioa' +
                 str(karpeta) + '.txt', 'w')
    fitx1.write('N = ' + str(N) + '\n')
    fitx1.write('D = ' + str(D) + '\n')
    fitx1.write('n = ' + str(n) + '\n')
    fitx1.write('G = ' + str(G) + '\n')
    fitx1.write('h = ' + str(h) + '\n')
    fitx1.write('loop = ' + str(loop + loop0) + '\n')
    fitx1.write('mtot = ' + str(mtot) + '\n')
    fitx1.write('xmax = ' + str(np.amax(x0)) + '\n')
    fitx1.write('xmin = ' + str(np.amin(x0)) + '\n')
    fitx1.write('ymax = ' + str(np.amax(y0)) + '\n')
    fitx1.write('ymin = ' + str(np.amin(y0)) + '\n')
    fitx1.write('zmax = ' + str(np.amax(z0)) + '\n')
    fitx1.write('zmin = ' + str(np.amin(z0)) + '\n')

    fitx1.write('\n----------Hasierako x-------------\n')
    np.savetxt(fitx1, x0, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako y-------------\n')
    np.savetxt(fitx1, y0, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako z-------------\n')
    np.savetxt(fitx1, z0, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako vx-------------\n')
    np.savetxt(fitx1, vx0, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako vy-------------\n')
    np.savetxt(fitx1, vy0, delimiter=' ', newline=' ')
    fitx1.write('\n----------Hasierako vz-------------\n')
    np.savetxt(fitx1, vz0, delimiter=' ', newline=' ')
    fitx1.write('\nTime = ' + str(Time + time.time() - aber))
    fitx1.write('\n----------Azken x-------------\n')
    np.savetxt(fitx1, x, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken y-------------\n')
    np.savetxt(fitx1, y, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken z-------------\n')
    np.savetxt(fitx1, z, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken vx-------------\n')
    np.savetxt(fitx1, vx, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken vy-------------\n')
    np.savetxt(fitx1, vy, delimiter=' ', newline=' ')
    fitx1.write('\n----------Azken vz-------------\n')
    np.savetxt(fitx1, vz, delimiter=' ', newline=' ')
    fitx1.close()
    fitx2.close()
    print('Programa honek ' + str(time.time() - aber) +
          's behar izan ditu exekutatzeko')
