# -*- coding: utf-8 -*-
"""
Created on Thu Sep 17 17:14:00 2020

@author: nerea
"""
import numpy as np
from matplotlib.animation import FuncAnimation, PillowWriter
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d
from itertools import count
from os import name
import sys


"""Karpetaren zenbakia finkatu"""


def update_plot(i, xmax, xmin, ymax, ymin, zmax, zmin):
    ax.cla()
    ax.set_xlim3d(xmin, xmax)
    ax.set_ylim3d(ymin, ymax)
    ax.set_zlim3d(zmin, zmax)
    x = r[i, 0:N]
    y = r[i, N:2*N]
    z = r[i, 2*N:3*N]
    ax.scatter(x, y, z, c=colors)


if __name__ == "__main__":
    if name == 'posix':
        slash = '/'
    else:
        slash = '\\'
    karpeta = 0
    irudiKop = 400  # Zenbat irudiz eratutako gif-a nahi dudan
    franerate = 100  # Zenbat fotograma milisegundoko
    karpetaIzena = 'Grabitazio-kolapsoa_Emaitza' + str(karpeta)

    fitx1 = open(str(karpetaIzena) + str(slash) + 'Informazioa' +
                 str(karpeta) + '.txt', 'r')
    kont = 0
    while True:
        esaldi = fitx1.readline()
        if esaldi.split()[0] == 'N':
            N = int((esaldi.split())[2])
        elif esaldi.split()[0] == 'loop':
            loop = int((esaldi.split())[2])
        elif esaldi.split()[0] == 'xmax':
            xmax = 1.1*float((esaldi.split())[2])
            esaldi = fitx1.readline()
            xmin = 1.1*float((esaldi.split())[2])
            esaldi = fitx1.readline()
            ymax = 1.1*float((esaldi.split())[2])
            esaldi = fitx1.readline()
            ymin = 1.1*float((esaldi.split())[2])
            esaldi = fitx1.readline()
            zmax = 1.1*float((esaldi.split())[2])
            esaldi = fitx1.readline()
            zmin = 1.1*float((esaldi.split())[2])
            break
        kont = kont + 1

    fitx1.close()

    filename2 = karpetaIzena + slash + 'Datuak' + str(karpeta) + '.txt'
    r = np.array(np.loadtxt(filename2, dtype=float))

    colors = np.linspace(0, 1, N)
    colors = colors.tolist()
    fig = plt.figure()
    ax = plt.axes(projection='3d')
    ax.set_xlim3d(xmin, xmax)
    ax.set_ylim3d(ymin, ymax)
    ax.set_zlim3d(zmin, zmax)
    zein = np.linspace(0, loop-1, num=irudiKop, dtype=int)
    frame = iter(list(zein))
    anim = FuncAnimation(fig, update_plot, frames=frame,
                         interval=1.0/franerate, repeat=False,
                         fargs=(xmax, xmin, ymax, ymin, zmax,
                                zmin), save_count=irudiKop)
    plt.show()
    writergif = PillowWriter(fps=franerate)
    anim.save(karpetaIzena + slash + 'Gif' + str(karpeta) + '.gif',
              writer=writergif)